import { BehaviorSubject, Subject } from 'rxjs';
import { tap, switchAll } from 'rxjs/operators';

const selfDependent = () => {
  const activeSubject = new BehaviorSubject(
    new Subject()
  );
  return [
    activeSubject.pipe(switchAll()),
    () => tap({
      next: (v) => activeSubject.value.next(v),
      error: (e) => {
        activeSubject.value.error(e);
        activeSubject.next(new Subject());
      },
      complete: () => {
        activeSubject.value.complete();
        activeSubject.next(new Subject());
      }
    })
  ];
};

export { selfDependent };
//# sourceMappingURL=self-dependent.mjs.map
